models/Etapa.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "etapa".
 *
 * @property int $numetapa
 * @property int $kms
 * @property string $salida
 * @property string $llegada
 * @property int|null $dorsal
 *
 * @property Maillot[] $códigos
 * @property Ciclista $dorsal0
 * @property Lleva[] $llevas
 * @property Puerto[] $puertos
 */
class Etapa extends \yii\db\ActiveRecord
{
    
    public $nombre, $puerts;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'etapa';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['numetapa', 'kms', 'salida', 'llegada'], 'required'],
            [['numetapa', 'kms', 'dorsal'], 'integer'],
            [['salida', 'llegada'], 'string', 'max' => 35],
            [['numetapa'], 'unique'],
            [['dorsal'], 'exist', 'skipOnError' => true, 'targetClass' => Ciclista::className(), 'targetAttribute' => ['dorsal' => 'dorsal']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'numetapa' => 'Numetapa',
            'kms' => 'Kms',
            'salida' => 'Salida',
            'llegada' => 'Llegada',
            'dorsal' => 'Dorsal',
        ];
    }

    /**
     * Gets query for [[Códigos]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getCódigos()
    {
        return $this->hasMany(Maillot::className(), ['código' => 'código'])->viaTable('lleva', ['numetapa' => 'numetapa']);
    }

    /**
     * Gets query for [[Dorsal0]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getDorsal0()
    {
        return $this->hasOne(Ciclista::className(), ['dorsal' => 'dorsal']);
    }

    /**
     * Gets query for [[Llevas]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getLlevas()
    {
        return $this->hasMany(Lleva::className(), ['numetapa' => 'numetapa']);
    }

    /**
     * Gets query for [[Puertos]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getPuertos()
    {
        return $this->hasMany(Puerto::className(), ['numetapa' => 'numetapa']);
    }
    
}

controllers/EtapaController.php
<?php

namespace app\controllers;

use app\models\Etapa;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EtapaController implements the CRUD actions for Etapa model.
 */
class EtapaController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Etapa models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Etapa::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'numetapa' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Etapa model.
     * @param int $numetapa Numetapa
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($numetapa)
    {
        return $this->render('view', [
            'model' => $this->findModel($numetapa),
        ]);
    }

    /**
     * Creates a new Etapa model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Etapa();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'numetapa' => $model->numetapa]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Etapa model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $numetapa Numetapa
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($numetapa)
    {
        $model = $this->findModel($numetapa);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Etapa model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $numetapa Numetapa
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($numetapa)
    {
        $this->findModel($numetapa)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Etapa model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $numetapa Numetapa
     * @return Etapa the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($numetapa)
    {
        if (($model = Etapa::findOne(['numetapa' => $numetapa])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    public function actionEtapasequipo(){
        
        //$team = Yii::$app->db->createCommand("select dorsal from ciclista where nomequipo = 'banesto'")->queryScalar();
        $team = 2;
        $dataProvider = new ActiveDataProvider([
            'query' => Etapa::find()->where("ciclista.nomequipo = 'banesto'")->innerJoinWith("dorsal0")->select("numetapa, kms, salida, llegada, ciclista.nombre, (select count(*) from puerto where etapa.numetapa = numetapa) puerts") //quitar este dorsal
        ]);
        
        return $this->render("etapas",[
            "dataProvider" => $dataProvider,
        ]);
    }
}

controllers/PuertoController.php
<?php

namespace app\controllers;

use app\models\Puerto;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * PuertoController implements the CRUD actions for Puerto model.
 */
class PuertoController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Puerto models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Puerto::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'nompuerto' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Puerto model.
     * @param string $nompuerto Nompuerto
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($nompuerto)
    {
        return $this->render('view', [
            'model' => $this->findModel($nompuerto),
        ]);
    }

    /**
     * Creates a new Puerto model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Puerto();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'nompuerto' => $model->nompuerto]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Puerto model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $nompuerto Nompuerto
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($nompuerto)
    {
        $model = $this->findModel($nompuerto);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'nompuerto' => $model->nompuerto]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Puerto model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $nompuerto Nompuerto
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($nompuerto)
    {
        $this->findModel($nompuerto)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Puerto model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $nompuerto Nompuerto
     * @return Puerto the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($nompuerto)
    {
        if (($model = Puerto::findOne(['nompuerto' => $nompuerto])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    public function actionPuertosganados($numtap){
        
        $dataProvider = new ActiveDataProvider([
            'query' => Puerto::find()->where("numetapa = $numtap and ciclista.nomequipo = 'banesto'")->innerJoinWith("dorsal0")
                ->select("nompuerto, altura, pendiente, categoria, ciclista.nombre, numetapa")
        ]);
        
        return $this->render("puertos",[
            "dataProvider" => $dataProvider,
        ]);
    }
    
    public function actionPuertosequipo() {
        $dataProvider = new ActiveDataProvider([
            'query' => Puerto::find()->where("ciclista.nomequipo = 'banesto'")->innerJoinWith("dorsal0")
                ->select("nompuerto, altura, pendiente, categoria, ciclista.nombre, numetapa")
        ]);
        
        return $this->render("puertos",[
           "dataProvider" => $dataProvider, 
        ]);
    }
}

views/etapa/_etapa.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
$clave = $model->numetapa;
?>

<div class="card centrar separator zoom">
    <div class="card-body text-white bg-banesto">                 

        <div class="caption">
            <h2>Etapa <?= $model->numetapa ?></h2>
            <p><?= $model->kms ?> KM</p>
            <?php echo Html::img('@web/images/etapas/etapa'.$clave.'.jpg', [
                'alt' => 'Imagen no encontrada', 'class' => 'imagen'
                ]) ?>
            <hr class="my4">
            <h4>Ganador: <br><?= $model->nombre?></h4>
            <!-- Mostrar contador de etapas ganadas -->
            <p><?= $model->salida?> - <?= $model->llegada?></p>
            <?php if ($model->puerts > 0): ?>
                <p><?= Html::a('Ver '.$model->puerts.' puertos',['/puerto/puertosganados','numtap' => $model->numetapa],['class'=>'btn btn-info'])?></p>
            <?php else: ?>
                <p class="btn btn-block" style="color: white">Sin Puertos</p>
            <?php endif; ?>
        </div>

    </div>
</div> 

views/etapa/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Etapa */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="etapa-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'numetapa')->textInput() ?>

    <?= $form->field($model, 'kms')->textInput() ?>

    <?= $form->field($model, 'salida')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'llegada')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'dorsal')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/etapa/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Etapa */

$this->title = 'Create Etapa';
$this->params['breadcrumbs'][] = ['label' => 'Etapas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="etapa-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/etapa/etapas.php
<?php
use yii\widgets\ListView;
use yii\helpers\Html;
use yii\helpers\HTMLPurifier;
use circulon\widgets\ColumnListView;
$titulo = "Etapas que hemos ganado";
?>

<div class="well well-sm separator"><h2 style="text-align: center; max-height: 80px"><?=$titulo?></h2></div>

<div class=""> <!-- List view obtenido en https://github.com/circulon/yii2-columnlistview -->
    <?= ColumnListView::widget([ //Mostrar las etapas en bloques de 4
        'dataProvider' => $dataProvider,
        'itemView' => '_etapa',
        'layout' => "{summary}\n{pager}\n{items}",
        'columns'=> 2,
    ]);
    ?>
</div>

views/etapa/index.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Etapas';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="etapa-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Etapa', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'numetapa',
            'kms',
            'salida',
            'llegada',
            'dorsal',
            [
                'class' => ActionColumn::className(),
                'urlCreator' => function ($action,  $model, $key, $index, $column) {
                    return Url::toRoute([$action, 'numetapa' => $model->numetapa]);
                 }
            ],
        ],
    ]); ?>


</div>

views/etapa/resultado.php
<?php
use yii\grid\GridView;
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
?>


 <div class="jumbotron">
     <h2>prueba</h2>
     <p class="lead">prueba</p>
     <div class="well">
         prueba
     </div>
 </div>
 
<?=
GridView::widget([
    'dataProvider' => $resultados,
    'columns' => $campos,
]);
?>

views/etapa/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Etapa */

$this->title = 'Update Etapa: ' . $model->numetapa;
$this->params['breadcrumbs'][] = ['label' => 'Etapas', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->numetapa, 'url' => ['view', 'numetapa' => $model->numetapa]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="etapa-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/etapa/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Etapa */

$this->title = $model->numetapa;
$this->params['breadcrumbs'][] = ['label' => 'Etapas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="etapa-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'numetapa' => $model->numetapa], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'numetapa' => $model->numetapa], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'numetapa',
            'kms',
            'salida',
            'llegada',
            'dorsal',
        ],
    ]) ?>

</div>